# Layout Builder Sections Access

## INTRODUCTION

This module adds two options for each Layout Builder Section to control access.

You can deactivate a Section at all or restrict access to certain roles.

For a full description of the module, visit the
[project page](https://www.drupal.org/project/layout_builder_sections_access).

Submit bug reports and feature suggestions, or track changes in the
[issue queue](https://www.drupal.org/project/issues/layout_builder_sections_access).

### Development goal

In Drupal's block management, there is the option to deactivate blocks
or restrict them to certain roles. We want to enable this for Layout
Build Sections as well.

There are some workarounds using the "visually-hidden" class, but this still
includes the information in the markup and can potentially lead to
information disclosures.

### How to use

After installing the module, two new options are available for each
section in the Layout Manager.

#### Disable Section

The current section is not delivered in the frontend.

#### Access per role

Only users with the selected roles can see this section. If no role is
selected, this section will be displayed for all roles.

### Technical implementation

The Layout Builder does not handle "#access" entries in the render array
after hook_preprocess_layout and has no render-event for sections (only for
SectionComponent). The module therefore sits at the end of the hook order and
removes the "content" array and is therefore compatible with the other Layout
Builder extensions we have tested.

### Core Upstream

The community is working on a visibility feature for Layout Builder:
See Issue #2916876

We will provide a update-hook when finished and published to core.

See Issue #3459914

## REQUIREMENTS

This module requires layout_builder from core.

## INSTALLATION

Install as you would normally install a contributed Drupal module.

See https://www.drupal.org/docs/extending-drupal/installing-modules for
further information.

No other libraries are required.

## CONFIGURATION

There are no general configurations or permissions for this module

The new functions are now available in the editing form of the layout builder.
